<script setup lang="ts">
import { useReceiptStore } from '@/stores/receipt'
import { computed, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Receipt } from '@/types/Receipt'
import { useBranchStore } from '@/stores/branch';
import receiptService from '@/services/receipt'
import type { Branch } from '@/types/Branch';
const branchStore = useBranchStore()
const receiptStore = useReceiptStore()
const dialog = ref(false)
const form = ref(false)
const refForm = ref<VForm | null>(null)
const receipt = ref<Receipt | null>(null)
function onSubmit() { }
function formatDate(date: any) {
  return new Date(date).toLocaleDateString('th-TH')
}

function closeDialog() {
  dialog.value = false
}
async function editItem(item: Receipt) {
  if (!item.id) return
  await receiptStore.getReceipts(item.id)
  dialog.value = true
  receipt.value = item
}

const selectedBranchId = ref<Branch>()

const filteredReceipts = computed(() => {
  console.log(selectedBranchId.value)
  if (!selectedBranchId.value) {
    console.log('1')
    console.log(receiptStore.receipts.filter((item) => item))
    return receiptStore.receipts.filter((item) => item)
  } else {
    console.log('2')
    console.log('selectedBranchId.value: ', selectedBranchId.value)
    console.log(receiptStore.receipts.filter((item) => item.branch?.name === selectedBranchId.value!.name!))
    return receiptStore.receipts.filter(
      (item) => item.branch?.name === selectedBranchId.value
    )
  }
})


onMounted(async () => {
  await branchStore.getBranches();
  await receiptStore.getReceipt()
  //await selectedBranchId
  console.log('branch' + branchStore.branches);
});


</script>

<template>
  <div>
    <v-sheet>
      <v-container v-if="branchStore.branches !== null">
        <v-row>
          <v-col cols="12" sm="12">
            <v-card class="mx-auto" style="height: 600px;">
              <v-toolbar flat>
                <v-toolbar-title>History</v-toolbar-title>
                <v-divider class="mx-4" inset vertical></v-divider>
                <v-spacer></v-spacer>
              </v-toolbar>

              <v-row>
                <v-card-text style="max-height: 100px; background-color: #fff;" class="mt-4 mr-2 ml-2">
                  <v-row>
                    <v-col cols="12" md="12">
                      <v-select label="เลือกสาขา" :items="branchStore.branches" v-model="selectedBranchId"
                        item-text="name" item-title="name" variant="outlined" density="compact" clearable filled rounded
                        bg-color="#ffcb5e"></v-select>
                    </v-col>
                  </v-row>
                </v-card-text>
              </v-row>
              <v-card>

                <v-table fixed-header height="530">
                  <thead>
                    <tr>
                      <th>ID</th>
                      <th>Date</th>
                      <th>TotalPrice</th>
                      <th>member</th>
                      <th>Detail</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr v-for="item in filteredReceipts" :key="item.id">
                      <td>{{ item.id }}</td>
                      <td>{{ formatDate(item.createdDate) }}</td>
                      <td>{{ item.totalPrice }}</td>
                      <td>{{ item.member?.fristName }}</td>
                      <td>
                        <v-icon @click="editItem(item)">mdi-pencil</v-icon>
                      </td>
                    </tr>
                  </tbody>
                </v-table>
              </v-card>
            </v-card>
          </v-col>
        </v-row>
      </v-container>
    </v-sheet>
  </div>

  <v-dialog v-model="dialog" persistent width="300">
    <v-card style="background-color: #fff5e8">
      <v-card-text>
        <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
          <v-container>
            <v-card-title class="text-h5">ใบเสร็จ</v-card-title>
            <v-card-text>********************************</v-card-text>

            <v-card-text style="text-align: left; padding-top: 0">วันที่ : {{ formatDate(receipt?.createdDate)
              }}</v-card-text>
            <v-card-text style="text-align: left; padding-top: 0">พนักงาน : {{ receipt?.user?.name }}</v-card-text>
            <v-card-text style="text-align: left; padding-top: 0">สาขา : {{ receipt?.user?.branch ?
              receipt.user.branch.name : '-' }}</v-card-text>

            <v-card-text style="text-align: left; padding-top: 0">สมาชิก : {{ receipt?.member?.fristName
              }}</v-card-text>
            <v-card-text style="border: 2">------------------------------------</v-card-text>
            <v-row style="padding-bottom: 0">
              <v-col> รายการ </v-col>
              <v-col> ราคา </v-col>
            </v-row>
            <v-row style="padding-bottom: 0" v-for="(item, index) in receiptStore.receipt?.receiptDetails" :key="index">
              <v-col>{{ item.name }}</v-col>
              <v-col>{{ item.price }}</v-col>
            </v-row>

            <v-card-text style="border: 2">------------------------------------</v-card-text>
            <v-card-text style="text-align: left; padding-top: 0">รวมทั้งสิ้น : {{ receipt?.totalPrice }}
              บาท</v-card-text>

            <v-card-text style="text-align: left; padding-top: 0">วิธีการชำระเงิน : {{
              receiptStore.selectPaymentOption
              }}</v-card-text>
          </v-container>
        </v-form>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn variant="text" @click="closeDialog()"> Close </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-sheet,
.v-card {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}

.custom-header {
  background-color: #ffcb5e;
}

.v-dialog {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background: rgba(0, 0, 0, 0.5);
  display: flex;
  justify-content: center;
  align-items: center;
}
</style>
